unit SysEditServType;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, dbtables, Mask, ToolEdit, CurrEdit;

type
  TSysEditServTypeForm = class(TForm)
    edtID: TEdit;
    lblID: TLabel;
    edtCode: TEdit;
    lblCode: TLabel;
    edtDescription: TEdit;
    lblDescription: TLabel;
    edtSupplierID: TEdit;
    lblSupplierID: TLabel;
    edtSupplier: TEdit;
    lblSupplier: TLabel;
    edtSystemID: TEdit;
    lblSystemID: TLabel;
    edtSystem: TEdit;
    lblSystem: TLabel;
    lblRevenueElementID: TLabel;
    lblExpenseElementID: TLabel;
    lblStartDate: TLabel;
    lblEndDate: TLabel;
    ckAdminFee: TCheckBox;
    ckExportToTims: TCheckBox;
    ckSplitService: TCheckBox;
    ckVRTServiceType: TCheckBox;
    ckNoCalls: TCheckBox;
    lblExpectedRent: TLabel;
    btnOk: TButton;
    btnCancel: TButton;
    edtStartDate: TDateEdit;
    edtEndDate: TDateEdit;
    edtExpectedRent: TCurrencyEdit;
    lblFrequency: TLabel;
    edtFrequency: TEdit;
    cbRevenueElement: TComboBox;
    cbExpenseElement: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOkClick(Sender: TObject);
    procedure edtFrequencyChange(Sender: TObject);
  private
    { Private declarations }
    AmendString : TStringList;
    AuditString : TStringlist;
    slElementIndex : TStringList;
    sUserName : string;
    lAppend : boolean;
    nFrequency : integer;
    lAudit : boolean;
    AuditActionUpdate : string;
    AuditActionDelete : string;
    AuditActionInsert : string;
    Original_ID          : string;
    Original_Description : string;
    Original_Code        : string;
    Original_SupplierID  : string;
    Original_SupplierName: string;
    Original_SystemID    : string;
    Original_SystemName  : string;
    Original_Frequency   : string;
    Original_RevenueID   : string;
    Original_ExpenseID   : string;
    Original_ExpectedRent: string;
    Original_StartDate   : string;
    Original_EndDate     : string;
    Original_CheckAdminFee       : boolean;
    Original_CheckExportToTims   : boolean;
    Original_CheckSplitService   : boolean;
    Original_CheckVRTServiceType : boolean;
    Original_CheckNoCalls        : boolean;
  protected
    procedure SetAppend(const Value: boolean);
    procedure SetID(const Value: integer);
    function GetID: integer;
    procedure SetCode(const Value: string);
    function GetCode: string;
    procedure SetDescription(const Value: string);
    function GetDescription: string;
    procedure SetFrequency(const Value: integer);
    function GetFrequency: integer;
    procedure SetSupplierID(const Value: integer);
    function GetSupplierID: integer;
    procedure SetSupplierName(const Value: string);
    procedure SetSystemID(const Value: integer);
    function GetSystemID: integer;
    procedure SetSystemName(const Value: string);
    procedure SetRevenueID(const Value: integer);
    function GetRevenueID: integer;
    procedure SetExpenseID(const Value: integer);
    function GetExpenseID: integer;
    procedure SetExpectedRent(const Value: Currency);
    function GetExpectedRent: Currency;
    procedure SetStartDate(const Value: TDateTime);
    function GetStartDate: TDateTime;
    procedure SetEndDate(const Value: TDateTime);
    function GetEndDate: TDateTime;
    procedure SetCheckAdminFee(Value: boolean);
    function GetCheckAdminFee: boolean;
    procedure SetCheckExportToTims(Value: boolean);
    function GetCheckExportToTims: boolean;
    procedure SetCheckSplitService(Value: boolean);
    function GetCheckSplitService: boolean;
    procedure SetCheckVRTServiceType(Value: boolean);
    function GetCheckVRTServiceType: boolean;
    procedure SetCheckNoCalls(Value: boolean);
    function GetCheckNoCalls: boolean;
  published
    property AppendMode: boolean read lAppend write SetAppend;
    property ID: integer read GetID write SetID;
    property Code: string read GetCode write SetCode;
    property Description: string read GetDescription write SetDescription;
    property Frequency: integer read GetFrequency write SetFrequency;
    property SupplierID: integer read GetSupplierID write SetSupplierID;
    property SupplierName: string write SetSupplierName;
    property SystemID: integer read GetSystemID write SetSystemID;
    property SystemName: string write SetSystemName;
    property RevenueElementID: integer read GetRevenueID write SetRevenueID;
    property ExpenseElementID: integer read GetExpenseID write SetExpenseID;
    property ExpectedRent: Currency read GetExpectedRent write SetExpectedRent;
    property StartDate: TDateTime read GetStartDate write SetStartDate;
    property EndDate: TDateTime read GetEndDate write SetEndDate;
    property AdminFee: boolean read GetCheckAdminFee write SetCheckAdminFee;
    property ExportToTims: boolean read GetCheckExportToTims write SetCheckExportToTims;
    property SplitService: boolean read GetCheckSplitService write SetCheckSplitService;
    property VRTServiceType: boolean read GetCheckVRTServiceType write SetCheckVRTServiceType;
    property NoCalls: boolean read GetCheckNoCalls write SetCheckNoCalls;
  public
    { Public declarations }
  end;

var
  SysEditServTypeForm: TSysEditServTypeForm;

implementation

uses
  DataMod, DateFunctions, GenFns, PPSysMain;

{$R *.DFM}

procedure TSysEditServTypeForm.FormCreate(Sender: TObject);
var
  qFormCreate : TQuery;
  sVRTID : string;
  ActionDescription : string;
begin
  lAppend := False;
  AmendString := TStringList.Create;
  AuditString := TStringList.Create;
  Original_ID          := '';
  Original_Code        := '';
  Original_Description := '';
  Original_Frequency   := '0';
  Original_SupplierID  := '';
  Original_SupplierName:= '';
  Original_SystemID    := '';
  Original_SystemName  := '';
  Original_RevenueID   := '';
  Original_ExpenseID   := '';
  Original_ExpectedRent:= CurrToStr(0.00);
  Original_StartDate   := '';
  Original_EndDate     := '';
  Original_CheckAdminFee       := False;
  Original_CheckExportToTims   := False;
  Original_CheckSplitService   := False;
  Original_CheckVRTServiceType := False;
  Original_CheckNoCalls        := False;
  sUserName := Trim(MainForm.OPERATORNAME);
  qFormCreate := TQuery.Create(SELF);
  qFormCreate.DatabaseName := 'dbPPdata';
  // Read the audit event IDs.
  qFormCreate.SQL.Add('SELECT *');
  qFormCreate.SQL.Add('FROM tEvent');
  qFormCreate.SQL.Add('WHERE Description LIKE ''Reference%''');
  qFormCreate.Open;
  while not qFormCreate.Eof do begin
    ActionDescription := UpperCase(qFormCreate.FieldByName('Description').AsString);
    if (Pos('UPDATE', ActionDescription) > 0) then
      AuditActionUpdate := qFormCreate.FieldByName('id').AsString
    else if (Pos('DELETE', ActionDescription) > 0) then
      AuditActionDelete := qFormCreate.FieldByName('id').AsString
    else if (Pos('INSERT', ActionDescription) > 0) then
      AuditActionInsert := qFormCreate.FieldByName('id').AsString;
    qFormCreate.Next;
  end;
  qFormCreate.Close;
  qFormCreate.SQL.Clear;
  // Create a list of Billing Periods and set the default to the most recent.
  slElementIndex := TStringList.Create;
  qFormCreate.SQL.Add('SELECT tCustomer.ID');
  qFormCreate.SQL.Add('FROM tCustomer');
  qFormCreate.SQL.Add('WHERE tCustomer.ShipTo LIKE ''VRT''');
  qFormCreate.Open;
  if qFormCreate.Bof and qFormCreate.Eof then
    sVRTID := '0'
  else
    sVRTID := IntToStr(qFormCreate['id']);
  qFormCreate.Close;
  qFormCreate.SQL.Clear;
  qFormCreate.SQL.Add('SELECT tElement.ID, (tElement.ElementCode + '+
    '(CASE WHEN tElement.Description IS NULL THEN '''' ELSE '+
    '''  '' + tElement.Description END)) AS "Code"');
  qFormCreate.SQL.Add('FROM tElement');
  qFormCreate.SQL.Add('WHERE tElement.CustomerID = '+sVRTID);
  qFormCreate.SQL.Add('AND tElement.ElementCode IS NOT NULL');
  qFormCreate.SQL.Add('AND tElement.Active = 1');
  qFormCreate.SQL.Add('ORDER BY tElement.ElementCode');
  qFormCreate.Open;
  while not qFormCreate.Eof do begin
    cbRevenueElement.Items.Add(qFormCreate['Code']);
    cbExpenseElement.Items.Add(qFormCreate['Code']);
    slElementIndex.Add(IntToStr(qFormCreate['ID']));
    qFormCreate.Next;
  end;
  qFormCreate.Close;
  qFormCreate.Free;
  lAudit := TestForAudit('tServiceType');
end;

procedure TSysEditServTypeForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  AmendString.Free;
  slElementIndex.Free;
end;

procedure TSysEditServTypeForm.SetAppend(const Value: boolean);
begin
  lAppend := Value;
  if lAppend then begin
    Caption := Caption + ' (ADD)';
  end  // if lAppend then begin.
  else begin
    Caption := Caption + ' (EDIT)';
  end;  // if lAppend then begin..else.
end;  // SetAppend.

procedure TSysEditServTypeForm.SetID(const Value: integer);
begin
  if (Value = 0) then Original_ID := ''
  else                Original_ID := IntToStr(Value);
  edtID.Text := Original_ID;
end;  // SetID.

function TSysEditServTypeForm.GetID: integer;
begin
  Result := StrToInt(Trim(edtID.Text));
end;  // GetID.

procedure TSysEditServTypeForm.SetCode(const Value: string);
begin
  Original_Code := Trim(Value);
  edtCode.Text := Original_Code;
end;  // SetCode.

function TSysEditServTypeForm.GetCode: string;
begin
  Result := Trim(edtCode.Text);
end;  // GetCode.

procedure TSysEditServTypeForm.SetDescription(const Value: string);
begin
  Original_Description := Trim(Value);
  edtDescription.Text := Original_Description;
end;  // SetDescription.

function TSysEditServTypeForm.GetDescription: string;
begin
  Result := Trim(edtDescription.Text);
end;  // GetDescription.

procedure TSysEditServTypeForm.SetFrequency(const Value: integer);
var
  Temp : string;
  TempValue : integer;
begin
  TempValue := Value;
  if (TempValue = 0) or (TempValue = 1) or (TempValue = 3) or (TempValue = 6) or
    (TempValue = 12) then begin
    nFrequency := TempValue;
  end;
  Temp := IntToStr(nFrequency);
  if (Length(edtFrequency.Text) = 0) or (edtFrequency.Text <> Temp) then begin
    Original_Frequency := Temp;
    edtFrequency.Text := Temp;
  end;
end;  // SetFrequency.

function TSysEditServTypeForm.GetFrequency: integer;
var
  TempValue : integer;
begin
  if (Length(Trim(edtFrequency.Text)) = 0) then
    TempValue := 0
  else
    TempValue := StrToInt(edtFrequency.Text);
  if (TempValue = 0) or (TempValue = 1) or (TempValue = 3) or (TempValue = 6) or
    (TempValue = 12) then begin
    nFrequency := TempValue;
  end;
  Result := nFrequency;
end;  // GetFrequency.

procedure TSysEditServTypeForm.SetSupplierID(const Value: integer);
begin
//  if (Value = 0) then Original_SupplierID := ''
//  else                Original_SupplierID := IntToStr(Value);
  Original_SupplierID := IntToStr(Value);
  edtSupplierID.Text := Original_SupplierID;
end;  // SetSupplierID.

function TSysEditServTypeForm.GetSupplierID: integer;
begin
  Result := StrToInt(Trim(edtSupplierID.Text));
end;  // GetSupplierID.

procedure TSysEditServTypeForm.SetSupplierName(const Value: string);
begin
  Original_SupplierName := Trim(Value);
  edtSupplier.Text := Original_SupplierName;
end;  // SetSupplierName.

procedure TSysEditServTypeForm.SetSystemID(const Value: integer);
begin
//  if (Value = 0) then Original_SystemID := ''
//  else                Original_SystemID := IntToStr(Value);
  Original_SystemID := IntToStr(Value);
  edtSystemID.Text := Original_SystemID;
end;  // SetSystemID.

function TSysEditServTypeForm.GetSystemID: integer;
begin
  Result := StrToInt(edtSystemID.Text);
end;  // GetSystemID.

procedure TSysEditServTypeForm.SetSystemName(const Value: string);
begin
  Original_SystemName := Trim(Value);
  edtSystem.Text := Original_SystemName;
end;  // SetSystemName.

procedure TSysEditServTypeForm.SetRevenueID(const Value: integer);
var
  sSelected : string;
  iCount : integer;
begin
  if (Value > 0) then begin
    sSelected := IntToStr(Value);
    for iCount := 0 to slElementIndex.Count - 1 do begin
      if (slElementIndex[iCount] = sSelected) then begin
        cbRevenueElement.ItemIndex := iCount;
        Original_RevenueID := sSelected;
        break;
      end;
    end;
  end;
end;  // SetRevenueID.

function TSysEditServTypeForm.GetRevenueID: integer;
var
  nSelected : integer;
begin
  nSelected := cbRevenueElement.ItemIndex;
  if (nSelected < 0) or (Length(Trim(cbRevenueElement.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(slElementIndex[nSelected]);
end;  // GetRevenueID.

procedure TSysEditServTypeForm.SetExpenseID(const Value: integer);
var
  sSelected : string;
  iCount : integer;
begin
  if (Value > 0) then begin
    sSelected := IntToStr(Value);
    for iCount := 0 to slElementIndex.Count - 1 do begin
      if (slElementIndex[iCount] = sSelected) then begin
        cbExpenseElement.ItemIndex := iCount;
        Original_ExpenseID := sSelected;
        break;
      end;
    end;
  end;
end;  // SetExpenseID.

function TSysEditServTypeForm.GetExpenseID: integer;
var
  nSelected : integer;
begin
  nSelected := cbExpenseElement.ItemIndex;
  if (nSelected < 0) or (Length(Trim(cbExpenseElement.Text)) = 0) then
    Result := 0
  else
    Result := StrToInt(slElementIndex[nSelected]);
end;  // GetExpenseID.

procedure TSysEditServTypeForm.SetExpectedRent(const Value: Currency);
begin
  Original_ExpectedRent := CurrToStr(Value);
  edtExpectedRent.Text := Original_ExpectedRent;
end;  // SetExpectedRent.

function TSysEditServTypeForm.GetExpectedRent: Currency;
begin
  Result := StrToCurr(edtExpectedRent.Text)
end;  // GetExpectedRent.

procedure TSysEditServTypeForm.SetStartDate(const Value: TDateTime);
begin
  if not VarIsNull(Value) then begin
    Original_StartDate := StandardDateString(Value);
    edtStartDate.Date := Value;
  end;
end;  // SetStartDate.

function TSysEditServTypeForm.GetStartDate: TDateTime;
begin
  if (Length(Original_StartDate)=8) then
       Result := edtStartDate.Date
  else Result := NULL;
end;  // GetStartDate.

procedure TSysEditServTypeForm.SetEndDate(const Value: TDateTime);
begin
  if not VarIsNull(Value) then begin
    Original_EndDate := StandardDateString(Value);
    edtEndDate.Date := Value;
  end;
end;  // SetEndDate.

function TSysEditServTypeForm.GetEndDate: TDateTime;
begin
  if (Length(Original_EndDate)=8) then
       Result := edtEndDate.Date
  else Result := NULL;
end;  // GetEndDate.

procedure TSysEditServTypeForm.SetCheckAdminFee(Value: boolean);
begin
  Original_CheckAdminFee := Value;
  ckAdminFee.Checked := Original_CheckAdminFee;
end;  // SetCheckAdminFee.

function TSysEditServTypeForm.GetCheckAdminFee: boolean;
begin
  Result := ckAdminFee.Checked;
end;  // SetCheckAdminFee.

procedure TSysEditServTypeForm.SetCheckExportToTims(Value: boolean);
begin
  Original_CheckExportToTims := Value;
  ckExportToTims.Checked := Original_CheckExportToTims;
end;  // SetExportToTims.

function TSysEditServTypeForm.GetCheckExportToTims: boolean;
begin
  Result := ckExportToTims.Checked;
end;  // GetExportToTims.

procedure TSysEditServTypeForm.SetCheckSplitService(Value: boolean);
begin
  Original_CheckSplitService := Value;
  ckSplitService.Checked := Original_CheckSplitService;
end;  // SetCheckSplitService.

function TSysEditServTypeForm.GetCheckSplitService: boolean;
begin
  Result := ckSplitService.Checked;
end;  // GetCheckSplitService.

procedure TSysEditServTypeForm.SetCheckVRTServiceType(Value: boolean);
begin
  Original_CheckVRTServiceType := Value;
  ckVRTServiceType.Checked := Original_CheckVRTServiceType;
end;  // SetCheckVRTServiceType.

function TSysEditServTypeForm.GetCheckVRTServiceType: boolean;
begin
  Result := ckVRTServiceType.Checked;
end;  // GetCheckVRTServiceType.

procedure TSysEditServTypeForm.SetCheckNoCalls(Value: boolean);
begin
  Original_CheckNoCalls := Value;
  ckNoCalls.Checked := Original_CheckNoCalls;
end;  // SetCheckNoCalls.

function TSysEditServTypeForm.GetCheckNoCalls: boolean;
begin
  Result := ckNoCalls.Checked;
end;  // GetCheckNoCalls.

procedure TSysEditServTypeForm.btnOkClick(Sender: TObject);
var
  q: TQuery;
  sField : string;
  sValue : string;
  sAuditInsert : string;
  sAuditField : string;
  sAuditValue : string;
//  AuditTrailDesc : string;
  AuditAction : string;
  lReturn : boolean;
  sStarted : string;
  nStarted : integer;
  sOriginal : string;          // Stores original value for when an ID=0;
  sError : string;
begin
  if lAppend then AuditAction := AuditActionInsert
  else            AuditAction := AuditActionUpdate;
  q := TQuery.Create(SELF);
  q.DatabaseName := 'dbPPdata';
  lReturn := False;
  if (Length(Trim(edtCode.Text)) > 0) and
    (Length(Trim(edtSupplierID.Text)) > 0) and
    ((ExpenseElementID >= 0) or (RevenueElementID >= 0)) then begin
    sStarted := Trim(edtCode.Text);
    if lAppend or (sStarted <> Original_Code) then begin
      q.SQL.Add('SELECT tServiceType.id');
      q.SQL.Add('FROM tServiceType');
      q.SQL.Add('WHERE tServiceType.Code LIKE '''+sStarted+'''');
      q.Open;
      lReturn := q.Eof;
      q.Close;
      q.SQL.Clear;
    end
    else begin
      lReturn := True;
    end;
    if lReturn then begin                     // Field value Okay!
      sStarted := Trim(edtSupplierID.Text);
      ProveWholeInteger(sStarted,lReturn);    // lReturn True if contents altered.
      lReturn := (not lReturn);               // Correct the logic.
      if not lReturn then begin               // Field value truncated - Error.
        edtSupplierID.Text := sStarted;
        sError := 'SupplierID MUST be an integer.';
      end
      else begin
        ProveForeignKey( 'tSupplier', StrToInt(sStarted), lReturn);
        if not lReturn then begin       // Field value truncated - Not Okay!
          edtSupplierID.Text := sStarted;
          sError := 'SupplierID does not exist.';
        end;  // not lReturn.
      end;  // if not lReturn then begin..else.
    end
    else begin
      edtCode.Text := sStarted;
      sError := 'The Code MUST be a unique value.';
    end;  // if not lReturn then begin..else.
    if lReturn then begin             // Field value truncated - Not Okay!
      if lAppend then begin
        sStarted := CleanString(Trim(edtCode.Text));
        AmendString.Add('INSERT INTO tServiceType');
        sField := '(Code,';
        sValue := 'VALUES ('''+ sStarted +''',';
        if lAudit then begin
{
          SetAuditSelect(sUserName, AuditAction, 'tServiceType',
            AuditString,sAuditField, sAuditValue);
          SetAuditData('CODE', '', sStarted, AuditTrailDesc);
}
          SetAuditStart(sUserName, AuditAction, 'tServiceType',
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditData('CODE', '', sStarted, AuditString);
        end;  // lAudit.
        sStarted := CleanString(Trim(edtDescription.Text));
        if (Length(sStarted) > 0) then begin
          sField := sField + 'Description,';
          sValue := sValue +''''+sStarted+''',';
          if lAudit then begin
            SetAuditData('DESCRIPTION', '', sStarted, AuditString);
          end;  // lAudit.
        end;
        sStarted := Trim(edtSupplierID.Text);
        sField := sField + 'SupplierID,AdminFee,';
        sValue := sValue + sStarted +',';
        if lAudit and (Length(sStarted) > 0) then begin
          SetAuditData('SUPPLIERID', '', sStarted, AuditString);
        end;  // lAudit.
        if (ckAdminFee.State = cbUnchecked) then begin
          sValue := sValue + '0,';
          if lAudit then begin
            SetAuditData('ADMINFEE', '', '0', AuditString);
          end;
        end
        else begin
          sValue := sValue + '1,';
          if lAudit then begin
            SetAuditData('ADMINFEE', '', '1', AuditString);
          end;
        end;
        nStarted := RevenueElementID;
        sStarted := IntToStr(nStarted);
        if (nStarted > 0) then begin
          sField := sField + 'RevenueElementID,';
          sValue := sValue + sStarted +',';
          if lAudit then begin
            SetAuditData('REVENUEELEMENTID', '', sStarted, AuditString);
          end;  // lAudit.
        end;
        nStarted := ExpenseElementID;
        sStarted := IntToStr(nStarted);
        if (nStarted > 0) then begin
          sField := sField + 'ExpenseElementID,';
          sValue := sValue + IntToStr(nStarted) +',';
          if lAudit then begin
            SetAuditData('EXPENSEELEMENTID', '', sStarted, AuditString);
          end;  // lAudit.
        end;
        sStarted := Trim(edtSystemID.Text);
        if Length(sStarted) > 0 then begin
          sField := sField + 'SystemID,';
          sValue := sValue + sStarted +',';
          if lAudit then begin
            SetAuditData('SYSTEMID', '', sStarted, AuditString);
          end;  // lAudit.
        end;
        sField := sField + 'ExportToTims,';
        if (ckExportToTims.State = cbUnchecked) then begin
          sValue := sValue + '0,';
          if lAudit then begin
            SetAuditData('EXPORTTOTIMS', '', '0', AuditString);
          end;
        end
        else begin
          sValue := sValue + '1,';
          if lAudit then begin
            SetAuditData('EXPORTTOTIMS', '', '1', AuditString);
          end;
        end;
        if (Length(Trim(edtStartDate.Text)) > 0) and
          (Copy(Trim(edtStartDate.Text),1,1) <> '/') then begin
          sStarted := StandardDateString(edtStartDate.Date);
          sField := sField + 'StartDate,';
          sValue := sValue + ''''+ sStarted +''',';
          if lAudit then begin
            SetAuditData('STARTDATE', '', sStarted, AuditString);
          end;
        end;
        if (Length(Trim(edtEndDate.Text)) > 0) and
          (Copy(Trim(edtEndDate.Text),1,1) <> '/') then begin
          sStarted := StandardDateString(edtEndDate.Date);
          sField := sField + 'EndDate,Active,';
          sValue := sValue + '''' + sStarted +'''0,';
          if lAudit then begin
            SetAuditData('ENDDATE', '', sStarted, AuditString);
            SetAuditData('ACTIVE', '', '0', AuditString);
          end;
        end
        else begin
          sField := sField + 'Active,';
          sValue := sValue + '1,';
          if lAudit then begin
            SetAuditData('ACTIVE', '', '1', AuditString);
          end;
        end;
        sField := sField + 'SplitService,VRTServiceType,';
        if (ckSplitService.State = cbUnchecked) then begin
          sValue := sValue + '0,';
          if lAudit then begin
            SetAuditData('SPLITSERVICE', '', '0', AuditString);
          end;
        end
        else begin
          sValue := sValue + '1,';
          if lAudit then begin
            SetAuditData('SPLITSERVICE', '', '1', AuditString);
          end;
        end;
        if (ckVRTServiceType.State = cbUnchecked) then begin
          sValue := sValue + '0,';
          if lAudit then begin
            SetAuditData('VRTSERVICETYPE', '', '0', AuditString);
          end;
        end
        else begin
          sValue := sValue + '1,';
          if lAudit then begin
            SetAuditData('VRTSERVICETYPE', '', '1', AuditString);
          end;
        end;
        if (edtExpectedRent.Value <> 0) then begin
          sStarted := Curr2Str(edtExpectedRent.Value);
          sField := sField + 'ExpectedRent,';
          sValue := sValue + sStarted +',';
          if lAudit then begin
            SetAuditData('EXPECTEDRENT', '', sStarted, AuditString);
          end;
        end;
        if (Frequency > 0) then begin
          sStarted := IntToStr(Frequency);
          sField := sField + 'Frequency,';
          sValue := sValue + sStarted +',';
          if lAudit then begin
            SetAuditData('FREQUENCY', '', sStarted, AuditString);
          end;
        end;
        sField := sField + 'NoCalls)';
        if (ckNoCalls.State = cbUnchecked) then begin
          sValue := sValue + '0)';
          if lAudit then begin
            SetAuditData('NOCALLS', '', '0', AuditString);
          end;
        end
        else begin
          sValue := sValue + '1)';
          if lAudit then begin
            SetAuditData('NOCALLS', '', '1', AuditString);
          end;
        end;
        AmendString.Add(sField);
        AmendString.Add(sValue);
{
        if lAudit and (Length(AuditTrailDesc) = 0) then begin
          lAudit := False;
        end;  // lAudit.
}
      end
      else begin                  ///////////////  UPDATE  ////////////////////
        sStarted := CleanString(Trim(edtCode.Text));
        AmendString.Add('UPDATE tServiceType');
        AmendString.Add('SET Code = '''+ sStarted +''',');
        if lAudit then begin
{
          SetAuditSelect(sUserName, AuditAction, 'tServiceType',
            AuditString,sAuditField, sAuditValue);
          sAuditField := sAuditField +',TableID';
          sAuditValue := sAuditValue +','+ Trim(edtID.Text);
          if (sStarted <> Original_Code) then begin
            SetAuditData('CODE', Original_Code, sStarted, AuditTrailDesc);
          end;
}
          SetAuditStart(sUserName, AuditAction, 'tServiceType',
            sAuditInsert, sAuditField, sAuditValue);
          SetAuditID(Trim(edtID.Text), sAuditValue);
          if (sStarted <> Original_Code) then begin
            SetAuditData('CODE', Original_Code, sStarted, AuditString);
          end;
        end;  // lAudit.
        sStarted := CleanString(Trim(edtDescription.Text));
        if (sStarted <> Original_Description) then begin
          sValue := 'Description = ';
          if (Length(sStarted) > 0) then sValue := sValue +''''+sStarted+''','
          else                           sValue := sValue + 'NULL,';
          AmendString.Add(sValue);
          if lAudit then begin
            SetAuditData('DESCRIPTION', Original_Description, sStarted,
              AuditString);
          end;
        end;  // changed.
        sStarted := Trim(edtSupplierID.Text);
        if (sStarted <> Original_SupplierID) then begin
          AmendString.Add('SupplierID = '+sStarted+',');
          if lAudit then begin
            SetAuditData('SUPPLIERID', Original_SupplierID, sStarted,
              AuditString);
          end;
        end;  // changed.
        nStarted := RevenueElementID;
        sStarted := IntToStr(nStarted);
        if (sStarted <> Original_RevenueID) then begin
          sOriginal := Original_RevenueID;                // Temp store value.
          sValue := 'RevenueElementID = ';
          if (nStarted > 0) then begin
            sValue := sValue + IntToStr(nStarted) +',';
            if lAudit and (Original_RevenueID = '0') then begin
              Original_RevenueID := '';                   // empty forces NULL.
            end;
          end
          else begin
            sValue := sValue + 'NULL,';
            sStarted := '';                               // empty forces NULL.
          end;
          AmendString.Add(sValue);
          if lAudit then begin
            SetAuditData('REVENUEELEMENTID', Original_RevenueID, sStarted,
              AuditString);
          end;  // lAudit.
          Original_RevenueID := sOriginal;                // Reinstates value.
        end;
        nStarted := ExpenseElementID;
        sStarted := IntToStr(nStarted);
        if (sStarted <> Original_ExpenseID) then begin
          sOriginal := Original_ExpenseID;                // Temp store value.
          sValue := 'ExpenseElementID = ';
          if (nStarted > 0) then begin
            sValue := sValue + IntToStr(nStarted) +',';
            if lAudit and (Original_ExpenseID = '0') then begin
              Original_ExpenseID := '';                   // empty forces NULL.
            end;
          end
          else begin
            sValue := sValue + 'NULL,';
            sStarted := '';                               // empty forces NULL.
          end;
          AmendString.Add(sValue);
          if lAudit then begin
            SetAuditData('EXPENSEELEMENTID', Original_ExpenseID, sStarted,
              AuditString);
          end;  // lAudit.
          Original_ExpenseID := sOriginal;                // Reinstates value.
        end;
        sStarted := Trim(edtSystemID.Text);
        if (sStarted <> Original_SystemID) then begin
          sOriginal := Original_SystemID;                 // Temp store value.
          sValue := 'SystemID = ';
          if (Length(sStarted) > 0) then begin
            sValue := sValue + sStarted +',';
            if lAudit and (Original_SystemID = '0') then begin
              Original_SystemID := '';                    // empty forces NULL.
            end;
          end
          else begin
            sValue := sValue + 'NULL,';
            sStarted := '';                               // empty forces NULL.
          end;
          AmendString.Add(sValue);
          if lAudit then begin
            SetAuditData('SYSTEMID', Original_SystemID, sStarted,
              AuditString);
          end;  // lAudit.
          Original_SystemID := sOriginal;                 // Reinstates value.
        end;
        sStarted := Trim(edtExpectedRent.Text);
        if (sStarted <> Original_ExpectedRent) then begin
          sValue := 'ExpectedRent = ';
          if (Length(sStarted) > 0) then begin
            sValue := sValue + sStarted + ',';
          end
          else begin
            sValue := sValue + 'NULL,';
          end;
          AmendString.Add(sValue);
          if lAudit then begin
            SetAuditData('EXPECTEDRENT', Original_ExpectedRent, sStarted,
              AuditString);
          end;  // lAudit.
        end;
        sStarted := IntToStr(Frequency);
        if (sStarted <> Original_Frequency) then begin
          sValue := 'Frequency = ';
          if (nFrequency = 0) then begin
            sValue := sValue + 'NULL,';
          end
          else begin
            sValue := sValue + sStarted +',';
          end;
          AmendString.Add(sValue);
          if lAudit then begin
            SetAuditData('FREQUENCY', Original_Frequency, sStarted,
              AuditString);
          end;  // lAudit.
        end;
        if (Length(Trim(edtStartDate.Text)) > 0) and
          (Copy(Trim(edtStartDate.Text),1,1) <> '/') then begin
          sStarted := StandardDateString(edtStartDate.Date);
          if (sStarted <> Original_StartDate) then begin
            sValue := ' StartDate = '''+sStarted+''',';
            AmendString.Add(sValue);
            if lAudit then begin
              SetAuditData('STARTDATE', Original_StartDate, sStarted,
                AuditString);
            end;
          end;
        end;
        if (Length(Trim(edtEndDate.Text)) = 0) or
          (Copy(Trim(edtEndDate.Text),1,1) = '/') then begin
          if (Length(Original_EndDate) = 8) then begin
            sValue := 'EndDate = NULL, Active = 1,';
            AmendString.Add(sValue);
            if lAudit then begin
              SetAuditData('ENDDATE', Original_EndDate, '', AuditString);
              SetAuditData('ACTIVE', '0', '1', AuditString);
            end;
          end;
        end
        else begin
          sStarted := StandardDateString(edtEndDate.Date);
          if (sStarted <> Original_EndDate) then begin
            sValue := 'EndDate = '''+sStarted+''', Active = 0,';
            AmendString.Add(sValue);
            if lAudit then begin
              SetAuditData('ENDDATE', Original_EndDate, sStarted, AuditString);
              if (Length(Original_EndDate) <> 8) then begin
                SetAuditData('ACTIVE', '1', '0', AuditString);
              end;
            end;
          end;
        end;
        if (ckAdminFee.Checked <> Original_CheckAdminFee) then begin
          sValue := 'AdminFee = ';
          if (ckAdminFee.State = cbUnchecked) then begin
            sValue := sValue +'0,';
            if lAudit then begin
              SetAuditData('ADMINFEE', '1', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +'1,';
            if lAudit then begin
              SetAuditData('ADMINFEE', '0', '1', AuditString);
            end;
          end;  // cbUnchecked.
          AmendString.Add(sValue);
        end;  // not Original_CheckAdminFee.
        if (ckExportToTims.Checked <> Original_CheckExportToTims) then begin
          sValue := 'ExportToTims = ';
          if (ckExportToTims.State = cbUnchecked) then begin
            sValue := sValue +'0,';
            if lAudit then begin
              SetAuditData('EXPORTTOTIMS', '1', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +'1,';
            if lAudit then begin
              SetAuditData('EXPORTTOTIMS', '0', '1', AuditString);
            end;
          end;  // cbUnchecked.
          AmendString.Add(sValue);
        end;  // not Original_CheckExportToTims.
        if (ckSplitService.Checked <> Original_CheckSplitService) then begin
          sValue := 'SplitService = ';
          if (ckSplitService.State = cbUnchecked) then begin
            sValue := sValue +'0,';
            if lAudit then begin
              SetAuditData('SPLITSERVICE', '1', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +'1,';
            if lAudit then begin
              SetAuditData('SPLITSERVICE', '0', '1', AuditString);
            end;
          end;  // cbUnchecked.
          AmendString.Add(sValue);
        end;  // not Original_CheckSplitService.
        if (ckVRTServiceType.Checked <> Original_CheckVRTServiceType) then begin
          sValue := 'VRTServiceType = ';
          if (ckVRTServiceType.State = cbUnchecked) then begin
            sValue := sValue +'0,';
            if lAudit then begin
              SetAuditData('VRTSERVICETYPE', '1', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +'1,';
            if lAudit then begin
              SetAuditData('VRTSERVICETYPE', '0', '1', AuditString);
            end;
          end;  // cbUnchecked.
          AmendString.Add(sValue);
        end;  // not Original_CheckVRTServiceType.
        if (ckNoCalls.Checked <> Original_CheckNoCalls) then begin
          sValue := 'NoCalls = ';
          if (ckNoCalls.State = cbUnchecked) then begin
            sValue := sValue +'0,';
            if lAudit then begin
              SetAuditData('NOCALLS', '1', '0', AuditString);
            end;
          end
          else begin
            sValue := sValue +'1,';
            if lAudit then begin
              SetAuditData('NOCALLS', '0', '1', AuditString);
            end;
          end;  // cbUnchecked.
          AmendString.Add(sValue);
        end;  // not Original_CheckNoCalls.
        // Done - remove the last trailing comma.
        with AmendString do begin
          sStarted := Strings[Count-1];
          Strings[Count-1] := Copy(sStarted,1,Length(sStarted)-1);
        end;
        sStarted := Trim(edtID.Text);
        AmendString.Add('WHERE id = '+ sStarted);
{
        // Make sure something has changed.
        if lAudit and (Length(AuditTrailDesc) = 0) then begin
          lAudit := False;
        end;  // lAudit.
}
      end;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceType');
            SQL.Add('WHERE Code LIKE '''+ Code +'''');
            SQL.Add('AND Active = 1');
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
{
      if lAudit and (Length(AuditTrailDesc) > 0) then begin
        sAuditField := sAuditField +',Description)';
        sAuditValue := sAuditValue +',';
        AuditTrailDesc := Copy(AuditTrailDesc,2,Length(AuditTrailDesc)-1);
        AuditTrailDesc := ''''+AuditTrailDesc+''')';
        AuditString.Add(sAuditField);
        AuditString.Add(sAuditValue);
        AuditString.Add(AuditTrailDesc);
        q.SQL := AuditString;
        q.ExecSQL;
}
      end;
    end;  // lReturn.
  end
  else begin
    sError := 'You must provide: Code, SupplierID, and either '+
      'RevenueElementID or ExpenseElementID.'
  end;
  AmendString.Clear;
  q.Free;
  if lReturn then begin
    ModalResult := mrOk;
  end
  else begin
    MessageDlg(sError, mtWarning, [mbOk], 0);
  end;  // lReturn.
end;  // btnOkClick().

procedure TSysEditServTypeForm.edtFrequencyChange(Sender: TObject);
var
  Value : string;
//  TempValue : string;
  lNotInteger : boolean;
  i : integer;
begin
  Value := Trim(edtFrequency.Text);
  if (Length(Value) = 0) then begin
    SetFrequency(0);
  end
  else begin
    lNotInteger := False;
    for i := 1 to Length(Value) do
      if (Pos(Copy(Value,i,1),'0123456789') = 0) then begin
        lNotInteger := True;
        break;
      end;
    if lNotInteger then edtFrequency.Text := Copy(Value,1,i-1)
    else                SetFrequency(StrToInt(Value));

//    TempValue := '~*'+Value+'~*';
//    if (Pos(TempValue,'~*0~*1~*3~*6~*12~*') = 0) then
//      edtFrequency.Text := IntToStr(GetFrequency);
//    SetFrequency(StrToInt(edtFrequency.Text));
  end;
end;

end.
