unit SysEditServiceSplit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Db, DBTables;

type
  TSplitForm = class(TForm)
    cbShipTo1: TComboBox;
    cbShipTo2: TComboBox;
    cbShipTo3: TComboBox;
    cbShipTo4: TComboBox;
    cbShipTo5: TComboBox;
    cbShipTo6: TComboBox;
    cbShipTo7: TComboBox;
    cbShipTo8: TComboBox;
    cbShipTo9: TComboBox;
    cbShipTo10: TComboBox;
    edtRent1: TEdit;
    edtRent2: TEdit;
    edtRent3: TEdit;
    edtRent4: TEdit;
    edtRent5: TEdit;
    edtRent6: TEdit;
    edtRent7: TEdit;
    edtRent8: TEdit;
    edtRent9: TEdit;
    edtRent10: TEdit;
    edtCalls1: TEdit;
    edtCalls2: TEdit;
    edtCalls3: TEdit;
    edtCalls4: TEdit;
    edtCalls5: TEdit;
    edtCalls6: TEdit;
    edtCalls7: TEdit;
    edtCalls8: TEdit;
    edtCalls9: TEdit;
    edtCalls10: TEdit;
    edtOther1: TEdit;
    edtOther2: TEdit;
    edtOther3: TEdit;
    edtOther4: TEdit;
    edtOther5: TEdit;
    edtOther6: TEdit;
    edtOther7: TEdit;
    edtOther8: TEdit;
    edtOther9: TEdit;
    edtOther10: TEdit;
    edtItem1: TEdit;
    edtItem2: TEdit;
    edtItem3: TEdit;
    edtItem4: TEdit;
    edtItem5: TEdit;
    edtItem6: TEdit;
    edtItem7: TEdit;
    edtItem8: TEdit;
    edtItem9: TEdit;
    edtItem10: TEdit;
    lblItem: TLabel;
    lblShipTo: TLabel;
    lblRent: TLabel;
    lblCalls: TLabel;
    lblOther: TLabel;
    lblServiceID: TLabel;
    lblServiceDescription: TLabel;
    lblHelp: TLabel;
    btnOk: TButton;
    btnCancel: TButton;
    qServiceID: TQuery;
    dbedtServiceDescription: TDBEdit;
    dsServiceID: TDataSource;
    qServiceIDID: TIntegerField;
    qServiceIDServiceID: TStringField;
    qServiceIDDescription: TStringField;
    cbServiceID: TDBLookupComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    lAppend : boolean;
    sUserName : string;
    AmendString : TStringList;
    AuditString : TStringlist;
    lAudit : boolean;
    AuditActionUpdate : string;
    AuditActionDelete : string;
    AuditActionInsert : string;
    AuditAction : string;
    sAuditInsert : string;
    sAuditField : string;
    sAuditValue : string;
    Original_ServiceID : string;
    procedure PopulateArray(const sServiceID: string);
    function CheckTotals: boolean;
    procedure SaveForAppend(var lSuccess: boolean);
    procedure SaveForEdit(var lSuccess: boolean);
  protected
    procedure SetAppend(Value: boolean);
    procedure SetServiceID(const Value: integer);
    function GetServiceID: integer;
  published
    property AppendMode: boolean read lAppend write SetAppend;
    property ServiceID: integer read GetServiceID write SetServiceID;
  public
    { Public declarations }
  end;

var
  SplitForm: TSplitForm;

implementation

uses
  DataMod, GenFns;

var
  slID : TStringList;
  slNames : TStringList;
  Original_ID : TStringList;
  Original_ShipTo : TStringList;
  Original_Rent : TStringList;
  Original_Calls : TStringList;
  Original_Other : TStringList;

{$R *.DFM}

procedure TSplitForm.FormCreate(Sender: TObject);
var
  q : TQuery;
  ActionDescription : string;
begin
  lAppend := False;
  slNames := TStringList.Create;
  slID := TStringList.Create;
  Original_ID := TStringList.Create;
  Original_ShipTo := TStringList.Create;
  Original_Rent := TStringList.Create;
  Original_Calls := TStringList.Create;
  Original_Other := TStringList.Create;
  q := TQuery.Create(SplitForm);
  q.DatabaseName := 'dbPPdata';
  with q do begin
    SQL.Add('SELECT ID, ShipTo');
    SQL.Add('FROM tCustomer');
    SQL.Add('WHERE Active = 1');
    SQL.Add('ORDER BY ShipTo');
    Open;
    while not Eof do begin
      slID.Add(FieldByName('ID').AsString);
      slNames.Add(FieldByName('ShipTo').AsString);
      Next;
    end;
    close;
    // Read the audit event IDs.
    SQL.Clear;
    SQL.Add('SELECT *');
    SQL.Add('FROM tEvent');
    SQL.Add('WHERE Description LIKE ''Reference%''');
    Open;
    while not q.Eof do begin
      ActionDescription := UpperCase(FieldByName('Description').AsString);
      if (Pos('UPDATE', ActionDescription) > 0) then
        AuditActionUpdate := FieldByName('id').AsString
      else if (Pos('DELETE', ActionDescription) > 0) then
        AuditActionDelete := FieldByName('id').AsString
      else if (Pos('INSERT', ActionDescription) > 0) then
        AuditActionInsert := FieldByName('id').AsString;
      Next;
    end;
    Close;
  end;  // q.
  q.Free;
  cbShipTo1.Items.Text := slNames.Text;
  cbShipTo1.CharCase := ecUpperCase;
  cbShipTo2.Items.Text := slNames.Text;
  cbShipTo2.CharCase := ecUpperCase;
  cbShipTo3.Items.Text := slNames.Text;
  cbShipTo3.CharCase := ecUpperCase;
  cbShipTo4.Items.Text := slNames.Text;
  cbShipTo4.CharCase := ecUpperCase;
  cbShipTo5.Items.Text := slNames.Text;
  cbShipTo5.CharCase := ecUpperCase;
  cbShipTo6.Items.Text := slNames.Text;
  cbShipTo6.CharCase := ecUpperCase;
  cbShipTo7.Items.Text := slNames.Text;
  cbShipTo7.CharCase := ecUpperCase;
  cbShipTo8.Items.Text := slNames.Text;
  cbShipTo8.CharCase := ecUpperCase;
  cbShipTo9.Items.Text := slNames.Text;
  cbShipTo9.CharCase := ecUpperCase;
  cbShipTo10.Items.Text := slNames.Text;
  cbShipTo10.CharCase := ecUpperCase;
  lAudit := TestForAudit('tServiceSplit');
end;  // FormCreate.

procedure TSplitForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  qServiceID.Close;
end;  // FormClose.

procedure TSplitForm.SetAppend(Value: boolean);
begin
  lAppend := Value;
  if lAppend then begin
    Caption := Caption + ' (ADD)';
    // Only allow the user to select services that ARE NOT in tServiceSplit.
    with qServiceID do begin
      SQL.Clear;
      SQL.Add('SELECT tServiceID.ID, tServiceID.ServiceID, tServiceID.Description');
      SQL.Add('FROM tServiceID');
      SQL.Add('LEFT JOIN tServiceSplit ON tServiceID.ID = tServiceSplit.ServiceID');
      SQL.Add('WHERE tServiceSplit.CustomerID IS NULL');
      SQL.Add('AND tServiceID.Active = 1');
      SQL.Add('ORDER BY tServiceID.ServiceID');
    end;  // qServiceID.
  end
  else begin
    Caption := Caption + ' (EDIT)';
    // Only show services that ARE in tServiceSplit.
    with qServiceID do begin
      SQL.Clear;
      SQL.Add('SELECT tServiceID.ID, tServiceID.ServiceID, tServiceID.Description');
      SQL.Add('FROM tServiceID');
      SQL.Add('LEFT JOIN tServiceSplit ON tServiceID.ID = tServiceSplit.ServiceID');
      SQL.Add('WHERE tServiceSplit.CustomerID IS NOT NULL');
      SQL.Add('AND tServiceID.Active = 1');
      SQL.Add('ORDER BY tServiceID.ServiceID');
    end;  // qServiceID.
  end;
  qServiceID.Open;
  cbServiceID.Enabled := lAppend;
end;  // SetAppend.

procedure TSplitForm.SetServiceID(const Value: integer);
var
  vValue : variant;
begin
  Original_ServiceID := IntToStr(Value);
  vValue := Value;
  with qServiceID do begin
    Locate('ID', vValue, [loCaseInsensitive, loPartialKey]);
  end;
  cbServiceID.KeyValue := qServiceID.FieldByName('ID').AsInteger;
  PopulateArray(Original_ServiceID);
end;  // SetServiceID.

function TSplitForm.GetServiceID: integer;
begin
  if (Length(Trim(cbServiceID.Text)) > 0) then
    Result := qServiceID.FieldByName('id').AsInteger
  else
    Result := 0;
end;  // GetServiceID.

procedure TSplitForm.PopulateArray(const sServiceID: string);
var
  qSplits : TQuery;
  nPos : integer;
  iCount : integer;
begin
  qSplits := TQuery.Create(SplitForm);
  with qSplits do begin
    DatabaseName := 'dbPPdata';
    SQL.Add('SELECT *');
    SQL.Add('FROM tServiceSplit');
    SQL.Add('WHERE ServiceID = '+sServiceID);
    SQL.Add('AND Active = 1');
    Open;
    // Add a dummy entry for array index=0. Ignored, arrays 1-10 are used.
    Original_ID.Add('');
    Original_ShipTo.Add('');
    Original_Rent.Add('');
    Original_Calls.Add('');
    Original_Other.Add('');
    for iCount := 0 to 10 do begin
      if eof then begin
        Original_ID.Add('');
        Original_ShipTo.Add('');
        Original_Rent.Add('');
        Original_Calls.Add('');
        Original_Other.Add('');
      end
      else begin
        nPos := slID.IndexOf(FieldByName('CustomerID').AsString);
        Original_ID.Add(IntToStr(FieldByName('ID').AsInteger));
        Original_ShipTo.Add(slNames.Strings[nPos]);
        Original_Rent.Add(FieldByName('RentPercentage').AsString);
        Original_Calls.Add(FieldByName('CallPercentage').AsString);
        Original_Other.Add(FieldByName('OtherPercentage').AsString);
      end;
      Next;
    end;
    Close;
    Free;
  end;  // qSplits.
  cbShipTo1.ItemIndex := slNames.IndexOf(Original_ShipTo[1]);
  edtRent1.Text  := Original_Rent[1];
  edtCalls1.Text := Original_Calls[1];
  edtOther1.Text := Original_Other[1];

  cbShipTo2.ItemIndex := slNames.IndexOf(Original_ShipTo[2]);
  edtRent2.Text  := Original_Rent[2];
  edtCalls2.Text := Original_Calls[2];
  edtOther2.Text := Original_Other[2];

  cbShipTo3.ItemIndex := slNames.IndexOf(Original_ShipTo[3]);
  edtRent3.Text  := Original_Rent[3];
  edtCalls3.Text := Original_Calls[3];
  edtOther3.Text := Original_Other[3];

  cbShipTo4.ItemIndex := slNames.IndexOf(Original_ShipTo[4]);
  edtRent4.Text  := Original_Rent[4];
  edtCalls4.Text := Original_Calls[4];
  edtOther4.Text := Original_Other[4];

  cbShipTo5.ItemIndex := slNames.IndexOf(Original_ShipTo[5]);
  edtRent5.Text  := Original_Rent[5];
  edtCalls5.Text := Original_Calls[5];
  edtOther5.Text := Original_Other[5];

  cbShipTo6.ItemIndex := slNames.IndexOf(Original_ShipTo[6]);
  edtRent6.Text  := Original_Rent[6];
  edtCalls6.Text := Original_Calls[6];
  edtOther6.Text := Original_Other[6];

  cbShipTo7.ItemIndex := slNames.IndexOf(Original_ShipTo[7]);
  edtRent7.Text  := Original_Rent[7];
  edtCalls7.Text := Original_Calls[7];
  edtOther7.Text := Original_Other[7];

  cbShipTo8.ItemIndex := slNames.IndexOf(Original_ShipTo[8]);
  edtRent8.Text  := Original_Rent[8];
  edtCalls8.Text := Original_Calls[8];
  edtOther8.Text := Original_Other[8];

  cbShipTo9.ItemIndex := slNames.IndexOf(Original_ShipTo[9]);
  edtRent9.Text  := Original_Rent[9];
  edtCalls9.Text := Original_Calls[9];
  edtOther9.Text := Original_Other[9];

  cbShipTo10.ItemIndex := slNames.IndexOf(Original_ShipTo[10]);
  edtRent10.Text  := Original_Rent[10];
  edtCalls10.Text := Original_Calls[10];
  edtOther10.Text := Original_Other[10];
end;  // PopulateArray.

function TSplitForm.CheckTotals: boolean;
var
  RentTotal  : integer;
  CallTotal  : integer;
  OtherTotal : integer;
  sTemp : string;
begin
  RentTotal  := 0;
  CallTotal  := 0;
  OtherTotal := 0;
  if (Length(Trim(cbShipTo1.Text)) > 0) then begin
    sTemp := Trim(edtRent1.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls1.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther1.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo2.Text)) > 0) then begin
    sTemp := Trim(edtRent2.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls2.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther2.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo3.Text)) > 0) then begin
    sTemp := Trim(edtRent3.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls3.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther3.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo4.Text)) > 0) then begin
    sTemp := Trim(edtRent4.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls4.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther4.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo5.Text)) > 0) then begin
    sTemp := Trim(edtRent5.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls5.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther5.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo6.Text)) > 0) then begin
    sTemp := Trim(edtRent6.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls6.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther6.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo7.Text)) > 0) then begin
    sTemp := Trim(edtRent7.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls7.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther7.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo8.Text)) > 0) then begin
    sTemp := Trim(edtRent8.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls8.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther8.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo9.Text)) > 0) then begin
    sTemp := Trim(edtRent9.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls9.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther9.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  if (Length(Trim(cbShipTo10.Text)) > 0) then begin
    sTemp := Trim(edtRent10.Text);
    if (Length(sTemp) > 0) then RentTotal  := RentTotal + StrToInt(sTemp);
    sTemp := Trim(edtCalls10.Text);
    if (Length(sTemp) > 0) then CallTotal  := CallTotal + StrToInt(sTemp);
    sTemp := Trim(edtOther10.Text);
    if (Length(sTemp) > 0) then OtherTotal := OtherTotal+ StrToInt(sTemp);
  end;
  Result := (RentTotal = 100) and (CallTotal = 100) and (OtherTotal = 100);
end;   // CheckTotals.

procedure TSplitForm.SaveForAppend(var lSuccess: boolean);
var
  q : TQuery;
  sTemp : string;
  sField0: string;
  sValue0: string;
  sField : string;
  sValue : string;
  sAuditBaseField : string;
  sAuditBaseValue : string;
  sServiceID : string;
  sCustomerID : string;
  lReturn : boolean;
begin
  // Note that the user can only select entries in active tServiceID that are
  // not already in tServiceSplit.
  AuditAction := AuditActionInsert;
  lReturn := False;
  q := TQuery.Create(SELF);
  q.DatabaseName := 'dbPPdata';
  sServiceID := IntToStr(ServiceID);
  AmendString := TStringList.Create;
  // Initiate the AMEND stringlist.
  AmendString.Add('INSERT INTO tServiceSplit');
  AmendString.Add(' ');
  AmendString.Add(' ');
  sField0 := '(ServiceID,CustomerID,';
  sValue0 := 'VALUES ('+sServiceID+',';
  if lAudit then begin
    SetAuditStart(sUserName, AuditAction, 'tServiceSplit',
      sAuditInsert, sAuditField, sAuditValue);
    // Save the base audit string values common for all new audit entries.
    sAuditBaseField := sAuditField;
    sAuditBaseValue := sAuditValue;
    SetAuditData('SERVICEID', '', Trim(cbServiceID.Text), AuditString);
  end;  // lAudit.
  if (Length(Trim(cbShipTo1.Text)) > 0) and
    ((Length(Trim(edtRent1.Text)) > 0) or
     (Length(Trim(edtCalls1.Text)) > 0) or
     (Length(Trim(edtOther1.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo1.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo1.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls1.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent1.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther1.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo1.

  if (Length(Trim(cbShipTo2.Text)) > 0) and
    ((Length(Trim(edtRent2.Text)) > 0) or
     (Length(Trim(edtCalls2.Text)) > 0) or
     (Length(Trim(edtOther2.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo2.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo2.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls2.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent2.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther2.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo2.

  if (Length(Trim(cbShipTo3.Text)) > 0) and
    ((Length(Trim(edtRent3.Text)) > 0) or
     (Length(Trim(edtCalls3.Text)) > 0) or
     (Length(Trim(edtOther3.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo3.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo3.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls3.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent3.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther3.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo3.

  if (Length(Trim(cbShipTo4.Text)) > 0) and
    ((Length(Trim(edtRent4.Text)) > 0) or
     (Length(Trim(edtCalls4.Text)) > 0) or
     (Length(Trim(edtOther4.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo4.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo4.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls4.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent4.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther4.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo4.

  if (Length(Trim(cbShipTo5.Text)) > 0) and
    ((Length(Trim(edtRent5.Text)) > 0) or
     (Length(Trim(edtCalls5.Text)) > 0) or
     (Length(Trim(edtOther5.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo5.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo5.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls5.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent5.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther5.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo5.

  if (Length(Trim(cbShipTo6.Text)) > 0) and
    ((Length(Trim(edtRent6.Text)) > 0) or
     (Length(Trim(edtCalls6.Text)) > 0) or
     (Length(Trim(edtOther6.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo6.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo6.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls6.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent6.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther6.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo6.

  if (Length(Trim(cbShipTo7.Text)) > 0) and
    ((Length(Trim(edtRent7.Text)) > 0) or
     (Length(Trim(edtCalls7.Text)) > 0) or
     (Length(Trim(edtOther7.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo7.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo7.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls7.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent7.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther7.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo7.

  if (Length(Trim(cbShipTo8.Text)) > 0) and
    ((Length(Trim(edtRent8.Text)) > 0) or
     (Length(Trim(edtCalls8.Text)) > 0) or
     (Length(Trim(edtOther8.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo8.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo8.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls8.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent8.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther8.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo8.

  if (Length(Trim(cbShipTo9.Text)) > 0) and
    ((Length(Trim(edtRent9.Text)) > 0) or
     (Length(Trim(edtCalls9.Text)) > 0) or
     (Length(Trim(edtOther9.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo9.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo9.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls9.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent9.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther9.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo9.

  if (Length(Trim(cbShipTo10.Text)) > 0) and
    ((Length(Trim(edtRent10.Text)) > 0) or
     (Length(Trim(edtCalls10.Text)) > 0) or
     (Length(Trim(edtOther10.Text)) > 0)) then begin
    sCustomerID := slID.Strings[cbShipTo10.ItemIndex];
    sField := sField0;
    sValue := sValue0 + sCustomerID +',';
    if lAudit then begin
      // Reset the audit data sets.
      sAuditField := sAuditBaseField;
      sAuditValue := sAuditBaseValue;
      AuditString.Clear;
      // Now save the data.
      SetAuditData('CUSTOMERID', '', Trim(cbShipTo10.Text), AuditString);
    end;  // lAudit.
    sTemp := Trim(edtCalls10.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'CallPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('CALLPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtRent10.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'RentPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('RENTPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    sTemp := Trim(edtOther10.Text);
    if (Length(sTemp) > 0) then begin
      sField := sField + 'OtherPercentage,';
      sValue := sValue + sTemp + ',';
      if lAudit then begin
        SetAuditData('OTHERPERCENTAGE', '', sTemp, AuditString);
      end;  // Audit.
    end;
    // Complete the SQL statement and save the data.
    if (Length(sField) > 0) then begin
      sField := sField + 'Active)';
      sValue := sValue + '1)';
      AmendString.Strings[1] := sField;
      AmendString.Strings[2] := sValue;
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        if lAppend then begin
          // Get and store the new ID for this table.
          with q do begin
            SQL.Clear;
            SQL.Add('SELECT ID');
            SQL.ADD('FROM tServiceSplit');
            SQL.Add('WHERE ServiceID = '+ sServiceID);
            SQL.Add('AND CustomerID = '+ sCustomerID);
            Open;
            SetAuditID(FieldByName('ID').AsString, sAuditValue);
            Close;
          end;
        end;  // lAppend.
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
      lReturn := True;
    end;  // sField.
  end;  // cbShipTo10.

  AmendString.Free;
  q.Free;
  if lReturn then begin
    ModalResult := mrOk;
  end
  else begin
//    MessageDlg(sError, mtWarning, [mbOk], 0);
  end;  // lReturn.
  lSuccess := lReturn;
end;  // SaveForAppend.

procedure TSplitForm.SaveForEdit(var lSuccess: boolean);
var
  q : TQuery;
  sServiceID : string;
  sCustomerID : string;
  sInsert1 : string;
  sInsert2 : string;
  sValue : string;
  sAuditBaseField : string;
  sAuditBaseValue : string;
  sAmount : string;
  sError : string;
  lSave : boolean;
  lAbort : boolean;
begin
  AuditAction := AuditActionUpdate;
  q := TQuery.Create(SELF);
  q.DatabaseName := 'dbPPdata';
  // Initiate the AMEND stringlist.
  sServiceID := IntToStr(ServiceID);
  sInsert1 := 'UPDATE tServiceSplit';
  sInsert2 := 'WHERE ID = ';
  sValue := '';
  // Initiate the AMEND stringlist.
  AmendString := TStringList.Create;
  if lAudit then begin
    SetAuditStart(sUserName, AuditAction, 'tServiceSplit',
      sAuditInsert, sAuditField, sAuditValue);
    // Save the base audit string values common for all new audit entries.
    sAuditBaseField := sAuditField;
    sAuditBaseValue := sAuditValue;
  end;  // lAudit.

  if (Length(Trim(cbShipTo1.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[1]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[1]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[1], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo1.Text) <> Original_ShipTo[1]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo1.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[1], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent1.Text);
    if not lAbort and (sAmount <> Original_Rent[1]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent1.Text := sAmount;
        sError := 'Whole integers only. Rent1 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[1], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent1.
    sAmount := Trim(edtCalls1.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[1]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls1.Text := sAmount;
        sError := 'Whole integers only. Calls1 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[1], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls1.
    sAmount := Trim(edtOther1.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[1]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther1.Text := sAmount;
        sError := 'Whole integers only. Other1 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[1], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[1]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[1], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo1=0.

  if (Length(Trim(cbShipTo2.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[2]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[2]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[2], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo2.Text) <> Original_ShipTo[2]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo2.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[2], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent2.Text);
    if not lAbort and (sAmount <> Original_Rent[2]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent2.Text := sAmount;
        sError := 'Whole integers only. Rent2 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[2], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent1.
    sAmount := Trim(edtCalls2.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[2]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls2.Text := sAmount;
        sError := 'Whole integers only. Calls2 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[2], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls1.
    sAmount := Trim(edtOther2.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[2]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther2.Text := sAmount;
        sError := 'Whole integers only. Other2 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[2], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[2]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[2], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo2=0.

  if (Length(Trim(cbShipTo3.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[3]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[3]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[3], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo3.Text) <> Original_ShipTo[3]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo3.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[3], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent3.Text);
    if not lAbort and (sAmount <> Original_Rent[3]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent3.Text := sAmount;
        sError := 'Whole integers only. Rent3 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[3], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent1.
    sAmount := Trim(edtCalls3.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[3]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls3.Text := sAmount;
        sError := 'Whole integers only. Calls3 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[3], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls1.
    sAmount := Trim(edtOther3.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[3]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther3.Text := sAmount;
        sError := 'Whole integers only. Other3 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[3], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[3]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[3], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo3=0.

  if (Length(Trim(cbShipTo4.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[4]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2+ Original_ID[4]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[4], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo4.Text) <> Original_ShipTo[4]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo4.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[4], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent4.Text);
    if not lAbort and (sAmount <> Original_Rent[4]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent4.Text := sAmount;
        sError := 'Whole integers only. Rent4 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[4], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent1.
    sAmount := Trim(edtCalls4.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[4]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls4.Text := sAmount;
        sError := 'Whole integers only. Calls4 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[4], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls1.
    sAmount := Trim(edtOther4.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[4]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther4.Text := sAmount;
        sError := 'Whole integers only. Other4 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[4], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[4]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[4], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo4=0.

  if (Length(Trim(cbShipTo5.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[5]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[5]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[5], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo5.Text) <> Original_ShipTo[5]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo5.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[5], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent5.Text);
    if not lAbort and (sAmount <> Original_Rent[5]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent2.Text := sAmount;
        sError := 'Whole integers only. Rent5 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[5], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent.
    sAmount := Trim(edtCalls5.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[5]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls5.Text := sAmount;
        sError := 'Whole integers only. Calls5 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[5], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls.
    sAmount := Trim(edtOther5.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[5]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther5.Text := sAmount;
        sError := 'Whole integers only. Other5 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[5], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // Other.
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[5]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[5], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo5=0.

  if (Length(Trim(cbShipTo6.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[6]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[6]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[6], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo6.Text) <> Original_ShipTo[6]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo6.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[6], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent6.Text);
    if not lAbort and (sAmount <> Original_Rent[6]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent6.Text := sAmount;
        sError := 'Whole integers only. Rent6 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[6], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent.
    sAmount := Trim(edtCalls6.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[6]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls6.Text := sAmount;
        sError := 'Whole integers only. Calls6 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[6], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls.
    sAmount := Trim(edtOther6.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[6]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther6.Text := sAmount;
        sError := 'Whole integers only. Other6 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[6], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // Other.
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[6]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[6], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo6=0.

  if (Length(Trim(cbShipTo7.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[7]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[7]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[7], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo7.Text) <> Original_ShipTo[7]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo7.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[7], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent7.Text);
    if not lAbort and (sAmount <> Original_Rent[7]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent7.Text := sAmount;
        sError := 'Whole integers only. Rent7 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[7], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent.
    sAmount := Trim(edtCalls2.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[7]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls7.Text := sAmount;
        sError := 'Whole integers only. Calls7 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[7], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls1.
    sAmount := Trim(edtOther7.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[7]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther7.Text := sAmount;
        sError := 'Whole integers only. Other7 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[7], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[7]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[7], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo7=0.

  if (Length(Trim(cbShipTo8.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[8]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[8]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[8], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo8.Text) <> Original_ShipTo[8]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo8.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[8], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent8.Text);
    if not lAbort and (sAmount <> Original_Rent[8]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent8.Text := sAmount;
        sError := 'Whole integers only. Rent8 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[8], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent.
    sAmount := Trim(edtCalls8.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[8]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls8.Text := sAmount;
        sError := 'Whole integers only. Calls8 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[8], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls1.
    sAmount := Trim(edtOther8.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[8]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther8.Text := sAmount;
        sError := 'Whole integers only. Other8 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[8], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[8]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[8], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo8=0.

  if (Length(Trim(cbShipTo9.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[9]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[9]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[9], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo9.Text) <> Original_ShipTo[9]) then begin        // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo9.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[9], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent9.Text);
    if not lAbort and (sAmount <> Original_Rent[9]) then begin        // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent9.Text := sAmount;
        sError := 'Whole integers only. Rent9 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[9], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent.
    sAmount := Trim(edtCalls9.Text);                                  // CALLS.
    if not lAbort and (sAmount <> Original_Calls[9]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls9.Text := sAmount;
        sError := 'Whole integers only. Calls9 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[9], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls.
    sAmount := Trim(edtOther9.Text);                                  // OTHER.
    if not lAbort and (sAmount <> Original_Other[9]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther9.Text := sAmount;
        sError := 'Whole integers only. Other9 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[9], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[9]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[9], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo9=0.

  if (Length(Trim(cbShipTo10.Text)) = 0) then begin
    // Empty CustomerID value, probably deleted.
    if (Length(Original_ShipTo[10]) > 0) then begin
      // "Delete" the entry from the table by setting Active = False.
      AmendString.Add(sInsert1);
      AmendString.Add('SET Active = 0');
      AmendString.Add(sInsert2 + Original_ID[10]);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('ACTIVE', '1', '0', AuditString);
        SetAuditID(Original_ID[10], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
        AuditString.Clear;
      end;  // lAudit.
    end;  // Original_ShipTo.
  end
  else begin
    // This entry is to be tested for changes.
    lSave := False;
    lAbort := False;
    if (Trim(cbShipTo10.Text) <> Original_ShipTo[10]) then begin      // SHIPTO.
      sCustomerID := slID.Strings[cbShipTo2.ItemIndex];
      sValue := 'SET CustomerID = '+sCustomerID+',';
      lSave := True;
      if lAudit then begin
        // Save the audit data.
        SetAuditData('CUSTOMERID', Original_ShipTo[10], sCustomerID, AuditString);
      end;
    end;
    sAmount := Trim(edtRent2.Text);
    if not lAbort and (sAmount <> Original_Rent[10]) then begin       // RENT.
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtRent10.Text := sAmount;
        sError := 'Whole integers only. Rent10 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'RentPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('RENTPERCENTAGE', Original_Rent[10], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtRent.
    sAmount := Trim(edtCalls10.Text);                                 // CALLS.
    if not lAbort and (sAmount <> Original_Calls[10]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtCalls10.Text := sAmount;
        sError := 'Whole integers only. Calls10 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'CallPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('CALLPERCENTAGE', Original_Calls[10], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;  // edtCalls.
    sAmount := Trim(edtOther10.Text);                                 // OTHER.
    if not lAbort and (sAmount <> Original_Other[2]) then begin
      if (Length(sAmount) > 0) then ProveWholeInteger(sAmount, lAbort);
      if lAbort then begin
        edtOther10.Text := sAmount;
        sError := 'Whole integers only. Other10 adjusted. Save aborted.';
      end
      else begin
        lSave := True;
        if (Length(sValue) = 0) then sValue := 'SET ';
        sValue := sValue + 'OtherPercentage = '+ sAmount+',';
        if lAudit then begin
          // Save the audit data.
          SetAuditData('OTHERPERCENTAGE', Original_Other[10], sAmount, AuditString);
        end;  // lAudit.
      end;  // lAbort.
    end;
    if lSave and not lAbort then begin
      // Remove the trailing comma.
      sValue := Copy(sValue,1,Length(sValue)-1);
      // Update the database.
      AmendString.Add(sInsert1);
      AmendString.Add(sValue);
      AmendString.Add(sInsert2 + Original_ID[10]);
      q.SQL := AmendString;
      q.ExecSQL;
      AmendString.Clear;
      // Record auditing data.
      if lAudit then begin
        SetAuditID(Original_ID[10], sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lSave.
    if lAudit then begin
      AuditString.Clear;
    end;  // lAudit.
    sValue := '';
  end;  // cbShipTo10=0.


  if lAbort then begin
    MessageDlg(sError, mtWarning, [mbOk], 0);
  end
  else begin
    AmendString.Free;
    q.Free;
    ModalResult := mrOk;
  end;  // lAbort.
end;  // SaveForEdit.

procedure TSplitForm.btnOkClick(Sender: TObject);
var
  lContinue : boolean;
begin
  // Check the number of records to be saved.
  // Check the totals.
  if not CheckTotals then begin
    MessageDlg('Integer totals are not 100. Please review your data.',
      mtWarning, [mbOk], 0);
  end
  else begin
    // Save the data.
    if lAppend then begin
      SaveForAppend(lContinue);
    end
    else begin
      SaveForEdit(lContinue);
    end;
    if lContinue then ModalResult := mrOk;
  end;
end;  // btnOk.

procedure TSplitForm.btnCancelClick(Sender: TObject);
begin
  // Check the totals.
  if not CheckTotals then begin
    MessageDlg('Integer totals are not 100. Please review your data.',
      mtWarning, [mbOk], 0);
  end
  else begin
    // Close the edit window.
    Close;
  end;
end;  // btnCancel.

end.
