unit SysEditSupplier;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DBCtrls, Db, DBTables;

type
  TSysEditSupplierForm = class(TForm)
    ckActive: TCheckBox;
    ckPlatinumUpdate: TCheckBox;
    ckVicTrack: TCheckBox;
    edtID: TEdit;
    edtSupplierName: TEdit;
    lblID: TLabel;
    lblSupplierName: TLabel;
    edtAddress01: TEdit;
    edtAddress02: TEdit;
    edtAddress03: TEdit;
    edtAddress04: TEdit;
    edtAddress05: TEdit;
    edtAddress06: TEdit;
    lblAddress01: TLabel;
    lblAddress02: TLabel;
    lblAddress03: TLabel;
    lblAddress04: TLabel;
    lblAddress05: TLabel;
    lblAddress06: TLabel;
    btnOk: TButton;
    btnCancel: TButton;
    lblPlatinumVendorID: TLabel;
    edtPlatinumVendorID: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
  private
    { Private declarations }
    lAppend : boolean;
    lAudit : boolean;
    AuditActionUpdate : string;
    AuditActionDelete : string;
    AuditActionInsert : string;
    sUserName : string;
    Original_SupplierName : string;
    Original_PlatinumVendorID : string;
    Original_PlatinumUpdate : boolean;
    Original_VicTrack : boolean;
    Original_Active : boolean;
    Original_Address01 : string;
    Original_Address02 : string;
    Original_Address03 : string;
    Original_Address04 : string;
    Original_Address05 : string;
    Original_Address06 : string;
  protected
    procedure SetAppend(Value: boolean);
    procedure SetID(Value: string);
    procedure SetSupplierName(const Value: string);
    function GetSupplierName: string;
    procedure SetPlatinumVendorID(const Value: string);
    function GetPlatinumVendorID: string;
    procedure SetPlatinumUpdate(const Value: boolean);
    function GetPlatinumUpdate: boolean;
    procedure SetVicTrack(const Value: boolean);
    function GetVicTrack: boolean;
    procedure SetActive(const Value: boolean);
    function GetActive: boolean;
    procedure SetAddress01(const Value: string);
    function GetAddress01: string;
    procedure SetAddress02(const Value: string);
    function GetAddress02: string;
    procedure SetAddress03(const Value: string);
    function GetAddress03: string;
    procedure SetAddress04(const Value: string);
    function GetAddress04: string;
    procedure SetAddress05(const Value: string);
    function GetAddress05: string;
    procedure SetAddress06(const Value: string);
    function GetAddress06: string;
  published
    property AppendMode: boolean read lAppend write SetAppend;
    property SupplierID: string write SetID;
    property SupplierName: string read GetSupplierName write SetSupplierName;
    property PlatinumVendorID: string read GetPlatinumVendorID write SetPlatinumVendorID;
    property PlatinumUpdate: boolean read GetPlatinumUpdate write SetPlatinumUpdate;
    property VicTrack: boolean read GetVicTrack write SetVicTrack;
    property Active: boolean read GetActive write SetActive;
    property Address01: string read GetAddress01 write SetAddress01;
    property Address02: string read GetAddress02 write SetAddress02;
    property Address03: string read GetAddress03 write SetAddress03;
    property Address04: string read GetAddress04 write SetAddress04;
    property Address05: string read GetAddress05 write SetAddress05;
    property Address06: string read GetAddress06 write SetAddress06;
  public
    { Public declarations }
  end;

const
  LEN_SUPPLIERNAME = 50;
  LEN_PLATINUMVENDORID  = 50;
  LEN_ADDRESS  = 255;

var
  SysEditSupplierForm: TSysEditSupplierForm;

implementation

uses
  PPSysMain, GenFns;

{$R *.DFM}

procedure TSysEditSupplierForm.FormCreate(Sender: TObject);
var
  qFormCreate : TQuery;
  ActionDescription : string;
begin
  sUserName := Trim(MainForm.OPERATORNAME);
  qFormCreate := TQuery.Create(SELF);
  qFormCreate.DatabaseName := 'dbPPdata';
  qFormCreate.SQL.Add('SELECT *');
  qFormCreate.SQL.Add('FROM tEvent');
  qFormCreate.SQL.Add('WHERE Description LIKE ''Reference%''');
  qFormCreate.Open;
  while not qFormCreate.Eof do begin
    ActionDescription := UpperCase(qFormCreate.FieldByName('Description').AsString);
    if (Pos('UPDATE', ActionDescription) > 0) then
      AuditActionUpdate := qFormCreate.FieldByName('id').AsString
    else if (Pos('DELETE', ActionDescription) > 0) then
      AuditActionDelete := qFormCreate.FieldByName('id').AsString
    else if (Pos('INSERT', ActionDescription) > 0) then
      AuditActionInsert := qFormCreate.FieldByName('id').AsString;
    qFormCreate.Next;
  end;
  qFormCreate.Close;
  qFormCreate.Free;
  lAudit := TestForAudit('tCustomer');
end;

procedure TSysEditSupplierForm.SetAppend(Value: boolean);
begin
  lAppend := Value;
  if lAppend then begin
    Caption := Caption + ' (ADD)';
    edtID.Text := '';
  end  // if lAppend then begin.
  else begin
    Caption := Caption + ' (EDIT)';
  end;  // if lAppend then begin..else.
end;  // SetAppend.

procedure TSysEditSupplierForm.SetID(Value: string);
begin
  if not lAppend then edtID.Text := Value;
end;  // SetID.

procedure TSysEditSupplierForm.SetSupplierName(const Value: string);
begin
  Original_SupplierName := Trim(Value);
  edtSupplierName.Text := Original_SupplierName;
end;  // SetSupplierName.

function TSysEditSupplierForm.GetSupplierName: string;
begin
  Result := Trim(edtSupplierName.Text);
end;  // GetSupplierName.

procedure TSysEditSupplierForm.SetPlatinumVendorID(const Value: string);
begin
  Original_PlatinumVendorID := Trim(Value);
  edtPlatinumVendorID.Text := Original_PlatinumVendorID;
end;

function TSysEditSupplierForm.GetPlatinumVendorID: string;
begin
  Result := Trim(edtPlatinumVendorID.Text);
end;

procedure TSysEditSupplierForm.SetPlatinumUpdate(const Value: boolean);
begin
  Original_PlatinumUpdate := Value;
  ckPlatinumUpdate.Checked := Original_PlatinumUpdate;
end;

function TSysEditSupplierForm.GetPlatinumUpdate: boolean;
begin
  Result := ckPlatinumUpdate.Checked;
end;

procedure TSysEditSupplierForm.SetVicTrack(const Value: boolean);
begin
  Original_VicTrack := Value;
  ckVicTrack.Checked := Original_VicTrack;
end;

function TSysEditSupplierForm.GetVicTrack: boolean;
begin
  Result := ckVicTrack.Checked;
end;

procedure TSysEditSupplierForm.SetActive(const Value: boolean);
begin
  Original_Active := Value;
  ckActive.Checked := Original_Active;
end;

function TSysEditSupplierForm.GetActive: boolean;
begin
  Result := ckActive.Checked;
end;

procedure TSysEditSupplierForm.SetAddress01(const Value: string);
begin
  Original_Address01 := Trim(Value);
  edtAddress01.Text := Original_Address01;
end;

function TSysEditSupplierForm.GetAddress01: string;
begin
  Result := Trim(edtAddress01.Text);
end;

procedure TSysEditSupplierForm.SetAddress02(const Value: string);
begin
  Original_Address02 := Trim(Value);
  edtAddress02.Text := Original_Address02;
end;

function TSysEditSupplierForm.GetAddress02: string;
begin
  Result := Trim(edtAddress02.Text);
end;

procedure TSysEditSupplierForm.SetAddress03(const Value: string);
begin
  Original_Address03 := Trim(Value);
  edtAddress03.Text := Original_Address03;
end;

function TSysEditSupplierForm.GetAddress03: string;
begin
  Result := Trim(edtAddress03.Text);
end;

procedure TSysEditSupplierForm.SetAddress04(const Value: string);
begin
  Original_Address04 := Trim(Value);
  edtAddress04.Text := Original_Address04;
end;

function TSysEditSupplierForm.GetAddress04: string;
begin
  Result := Trim(edtAddress04.Text);
end;

procedure TSysEditSupplierForm.SetAddress05(const Value: string);
begin
  Original_Address05 := Trim(Value);
  edtAddress05.Text := Original_Address05;
end;

function TSysEditSupplierForm.GetAddress05: string;
begin
  Result := Trim(edtAddress05.Text);
end;

procedure TSysEditSupplierForm.SetAddress06(const Value: string);
begin
  Original_Address06 := Trim(Value);
  edtAddress06.Text := Original_Address06;
end;

function TSysEditSupplierForm.GetAddress06: string;
begin
  Result := Trim(edtAddress06.Text);
end;

procedure TSysEditSupplierForm.btnOkClick(Sender: TObject);
var
  qSupp : TQuery;
  AmendString : TStringList;
  AuditString : TStringlist;
  sField : string;
  sValue : string;
  sTempValue : string;
  sAuditInsert : string;
  sAuditField : string;
  sAuditValue : string;
  AuditAction : string;
  sOperatorName: string;
  slFieldList : TStringList;
  slValueList : TStringList;
  nCount : integer;
  nMaxCount : integer;
  sStarted : string;
begin
  if lAppend then AuditAction := AuditActionInsert
  else            AuditAction := AuditActionUpdate;
  sOperatorName := MainForm.OPERATORNAME;
  AmendString := TStringList.Create;
  AuditString := TStringList.Create;
  if lAppend then begin
    slFieldList := TStringList.Create;
    slValueList := TStringList.Create;
    if lAudit then begin
      SetAuditStart(sUserName, AuditAction, 'tSupplier',
        sAuditInsert, sAuditField, sAuditValue);
    end;  // lAudit.
    AmendString.Add('INSERT INTO tSupplier');
    sField := '(SupplierName, PlatinumVendorID, Active,';
    sStarted := Copy(SupplierName,1,LEN_SUPPLIERNAME);
    if (Length(sStarted) = 0) then sValue := sValue + 'NULL,'
    else begin
      sValue := sValue +''''+sStarted+''',';
      if lAudit then begin
        SetAuditData('SUPPLIERNAME', '', sStarted, AuditString);
      end;
    end;
    sStarted := Copy(PlatinumVendorID,1,LEN_PLATINUMVENDORID);
    if (Length(sStarted) = 0) then sValue := sValue +'NULL,'
    else begin
      sValue := sValue + ''''+sStarted+''',';
      if lAudit then begin
        SetAuditData('PLATINUMVENDORID', '', sStarted, AuditString);
      end;
    end;
    if lAudit then begin
      SetAuditData('ACTIVE', '', '1', AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add('VALUES ('+ sValue +'1,');
    sField := '';
    sValue := '';

    sField := 'PlatinumUpdate, VicTrack,';
    if PlatinumUpdate then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('PLATINUMUPDATE', '', sTempValue, AuditString);
    end;
    if VicTrack then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('VICTRACK', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sTempValue := Copy(Address01,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address01,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS01', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Address02,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address02,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS02', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Address03,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address03,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS03', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Address04,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address04,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS04', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Address05,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address05,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS05', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Address06,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address06,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS06', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    // Last char must be a closed parenthesis.
    sField := slFieldList[slFieldList.Count-1];
    sField := Copy(sField, 1, Length(sField)-1) + ')';
    slFieldList[slFieldList.Count-1] := sField;
    sValue := slValueList[slValueList.Count-1];
    sValue := Copy(sValue, 1, Length(sValue)-1) + ')';
    slValueList[slValueList.Count-1] := sValue;
    // Now compose the full SQL statement.
    nMaxCount := slFieldList.Count - 1;
    for nCount := 0 to nMaxCount do AmendString.Add(slFieldList[nCount]);
    for nCount := 0 to nMaxCount do AmendString.Add(slValueList[nCount]);
  end  // if lAppend then begin.
  else begin
    AmendString.Add('UPDATE tSupplier');
    sTempValue := Copy(SupplierName,1,LEN_SUPPLIERNAME);
    if lAudit then begin
      SetAuditStart(sUserName, AuditAction, 'tSupplier',
        sAuditInsert, sAuditField, sAuditValue);
      SetAuditID(Trim(edtID.Text), sAuditValue);
      if (sTempValue <> Original_SupplierName) then begin
        SetAuditData('SUPPLIERNAME', Original_SupplierName, sTempValue, AuditString);
      end;
    end;  // lAudit.
    if (Length(sTempValue)=0) then sTempValue := 'NULL,'
    else                           sTempValue := ''''+sTempValue+''',';
    sValue := ' SET SupplierName = '+ sTempValue;
    sTempValue := Copy(PlatinumVendorID,1,LEN_SUPPLIERNAME);
    if (sTempValue <> Original_PlatinumVendorID) then begin
      if lAudit then begin
        SetAuditData('PLATINUMVENDORID', Original_PlatinumVendorID, sTempValue,
          AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' PlatinumVendorID = '+ sTempValue;
    end;
    AmendString.Add(sValue);
    sValue := '';

    if PlatinumUpdate then begin
      sTempValue := '1,';
      if lAudit and  not Original_PlatinumUpdate then begin
        SetAuditData('PLATINUMUPDATE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_PlatinumUpdate then begin
        SetAuditData('PLATINUMUPDATE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' PlatinumUpdate = '+sTempValue;
    if VicTrack then begin
      sTempValue := '1,';
      if lAudit and  not Original_VicTrack then begin
        SetAuditData('VICTRACK', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_VicTrack then begin
        SetAuditData('VICTRACK', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' VicTrack = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := Copy(Address01,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address01) then begin
      if lAudit then begin
        SetAuditData('ADDRESS01', Original_Address01, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address01 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address02,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address02) then begin
      if lAudit then begin
        SetAuditData('ADDRESS02', Original_Address02, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address02 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address03,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address03) then begin
      if lAudit then begin
        SetAuditData('ADDRESS03', Original_Address03, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address03 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address04,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address04) then begin
      if lAudit then begin
        SetAuditData('ADDRESS04', Original_Address04, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address04 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address05,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address05) then begin
      if lAudit then begin
        SetAuditData('ADDRESS05', Original_Address05, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address05 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address06,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address06) then begin
      if lAudit then begin
        SetAuditData('ADDRESS06', Original_Address06, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address06 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;

    // Done - remove the last trailing comma.
    with AmendString do begin
      sStarted := Strings[Count-1];
      Strings[Count-1] := Copy(sStarted,1,Length(sStarted)-1);
    end;
    AmendString.Add('WHERE id = '+ Trim(edtID.Text));
  end;  // if lAppend then begin..else.
  qSupp := TQuery.Create(SELF);
  qSupp.DatabaseName := 'dbPPdata';
  qSupp.SQL := AmendString;
  qSupp.ExecSQL;
  if lAudit then begin
    if lAppend then begin
      // Get and store the new ID for this table.
      with qSupp do begin
        SQL.Clear;
        SQL.Add('SELECT ID');
        SQL.ADD('FROM tSupplier');
        SQL.Add('WHERE SupplierName LIKE '''+ Suppliername +'''');
        SQL.Add('AND Active = 1');
        Open;
        SetAuditID(FieldByName('ID').AsString, sAuditValue);
        Close;
      end;
    end;  // lAppend.
    SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
  end;
  AmendString.Free;
  AuditString.Free;
  ModalResult := mrOk;
  qSupp.Free;
end;  // btnOkClick.

end.
